﻿using System;
using System.Transactions;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace DataModel
{
  [TestClass]
  public class EmployeeTest
  {
    [TestMethod]
    [ExpectedValidationException(MemberName = "BirthDate")]
    public void BirthDate_Between1900And2050()
    {
      using (new TransactionScope())
      using (var context = new NorthwindEntities())
      using (new GenericPrincipalScope("Mike", new[] { "Manager" }))
      {
        var employee = new Employee();
        employee.BirthDate = new DateTime(74, 1, 1);
        context.Employees.AddObject(employee);
        context.SaveChanges();
      }
    }
  }
}
