﻿
namespace DataModel
{
  using System.ComponentModel.DataAnnotations;
  using Unleashed.DataAnnotations;

  [MetadataType(typeof(Metadata))]
  partial class Supplier
  {
    [Authorization(
      Allow.Roles, "Manager",
      Allow.Roles, "Employee", Actions.Read,
      Deny.Users, "*")]
    private abstract class Metadata
    {
      [Display(Name = "Name", Order = 1)]
      public object ContactName { get; set; }

      [Display(Name = "Title", Order = 2)]
      public object ContactTitle { get; set; }

      [Display(Name = "Company", Order = 3)]
      public object CompanyName { get; set; }

      [Display(Order = 4)]
      public object Phone { get; set; }

      [Display(Order = 5)]
      public object Fax { get; set; }

      [Display(Name = "Street")]
      public object Address { get; set; }

      [Display(Name = "State")]
      public object Region { get; set; }

      [Display(Name = "Zip")]
      public object PostalCode { get; set; }

      [DataType(DataType.Url)]
      [RegularExpression(@"(?i)(http|https)://[a-z0-9\-\.]+\.(com|org|net|mil|edu)", ErrorMessage = "Home Page must be a valid URL")]
      public object HomePage { get; set; }
    }
  }
}
