﻿CREATE PROCEDURE [dbo].[FulfillOrder]
	@orderId int 
AS
BEGIN
  UPDATE Orders SET 
    OrderStatus = 3,
    ShippedDate = GETDATE()
  WHERE OrderID = @orderId 
    AND OrderStatus = 2;

  IF @@ROWCOUNT = 0
  BEGIN
    RAISERROR ('Order status must be Paid for the order to be fulfilled', 11, 0);
    RETURN;
  END;

  UPDATE Products SET
    UnitsInStock = UnitsInStock - od.Quantity
  FROM Products AS p
  JOIN [Order Details] AS od ON p.ProductID = od.ProductID
  WHERE od.OrderID = @orderId;
END