﻿CREATE PROCEDURE [dbo].[Products_Insert]
	@ProductName nvarchar(40), @SupplierID int,
  @CategoryID int, @QuantityPerUnit nvarchar(20), 
  @UnitPrice money, @UnitsInStock smallint, 
  @UnitsOnOrder smallint, @ReorderLevel smallint,
  @Discontinued bit, @RowsAffected int out
AS
BEGIN
	INSERT INTO Products 
    (ProductName, SupplierID, CategoryID, 
    QuantityPerUnit, UnitPrice, UnitsInStock, 
    UnitsOnOrder, ReorderLevel, Discontinued)
  VALUES 
    (@ProductName, @SupplierID, @CategoryID, 
    @QuantityPerUnit, @UnitPrice, @UnitsInStock, 
    @UnitsOnOrder, @ReorderLevel, @Discontinued);

  SET @RowsAffected = @@ROWCOUNT;

  SELECT SCOPE_IDENTITY() as ProductID;
END