﻿set identity_insert dbo.Shippers on;

merge into dbo.Shippers as target
using (values 
  (1, 'Speedy Express', '(503) 555-9831'),
  (2, 'United Package', '(503) 555-3199'),
  (3, 'Federal Shipping', '(503) 555-9931'))
  as source(ShipperID, CompanyName, Phone)
on target.ShipperID = source.ShipperID
when matched then 
  update set
    CompanyName = source.CompanyName,
    Phone = source.Phone
when not matched by target then
  insert (ShipperID, CompanyName, Phone)
  values (source.ShipperID, source.CompanyName, source.Phone);

set identity_insert dbo.Shippers off;
