﻿// Copyright © Microsoft Corporation.  All Rights Reserved.
// This code released under the terms of the 
// Microsoft Public License (MS-PL, http://opensource.org/licenses/ms-pl.html.)

using System.Reflection;
using System.Text;

namespace System.Linq.Dynamic
{
  public abstract class DynamicClass
  {
    public override string ToString()
    {
      PropertyInfo[] props = this.GetType().GetProperties(BindingFlags.Instance | BindingFlags.Public);
      StringBuilder sb = new StringBuilder();
      sb.Append("{");
      for (int i = 0; i < props.Length; i++)
      {
        if (i > 0) sb.Append(", ");
        sb.Append(props[i].Name);
        sb.Append("=");
        sb.Append(props[i].GetValue(this, null));
      }

      sb.Append("}");
      return sb.ToString();
    }
  }
}
