﻿// Copyright © Microsoft Corporation.  All Rights Reserved.
// This code released under the terms of the 
// Microsoft Public License (MS-PL, http://opensource.org/licenses/ms-pl.html.)

namespace System.Linq.Dynamic
{
  public class DynamicProperty
  {
    private string name;
    private Type type;

    public DynamicProperty(string name, Type type)
    {
      if (name == null) throw new ArgumentNullException("name");
      if (type == null) throw new ArgumentNullException("type");
      this.name = name;
      this.type = type;
    }

    public string Name
    {
      get { return name; }
    }

    public Type Type
    {
      get { return type; }
    }
  }

}
