namespace Unleashed.DynamicData
{
  using System;
  using System.Linq;
  using System.Web.DynamicData;
  using Unleashed.DataAnnotations;

  public class UnleashedEntity: DynamicEntity
  {
    protected override void OnLoad(EventArgs e)
    {
      this.Load += this.InitializeFromMetadata;
      base.OnLoad(e);
    }

    private void InitializeFromMetadata(object sender, EventArgs e)
    {
      if (this.ViewState["UIHint"] == null)
      {
        MetaTable table = this.FindMetaTable();
        var attribute = table.Attributes.OfType<EntityUIHintAttribute>().FirstOrDefault();
        if (attribute != null)
          this.UIHint = attribute.EntityUIHint;
      }

      var entityTemplate = this.TemplateControl as EntityTemplateUserControl;
      if (entityTemplate != null)
      {
        if (this.ViewState["Mode"] == null)
          this.Mode = entityTemplate.Mode;
        if (this.ViewState["ValidationGroup"] == null)
          this.ValidationGroup = entityTemplate.ValidationGroup;
      }
    }
  }
}