namespace Unleashed.DynamicData
{
  using System;
  using System.Web.DynamicData;
  using System.Web.DynamicData.ModelProviders;

  public class UnleashedMetaModel : MetaModel
  {
    public UnleashedMetaModel() : this(true)
    {
    }

    public UnleashedMetaModel(bool registerGlobally) : base(registerGlobally)
    {
      this.FilterFactory = new UnleashedFilterFactory(this);
    }

    protected override MetaTable CreateTable(TableProvider provider)
    {
      return new UnleashedMetaTable(this, provider);
    }

    public new void RegisterContext(Type context, ContextConfiguration configuration)
    {
      var originalModel = new MetaModel(false); // don't register globally
      originalModel.RegisterContext(context, configuration);
      DataModelProvider originalProvider = originalModel.Tables[0].Provider.DataModel;
      this.RegisterContext(new UnleashedModelProvider(originalProvider), configuration);
    }
  }
}