namespace Unleashed.DynamicData
{
  using System;
  using System.Collections.ObjectModel;
  using System.Linq;
  using System.Web.DynamicData.ModelProviders;

  public sealed class UnleashedModelProvider: DataModelProvider
  {
    private readonly DataModelProvider original;
    private readonly ReadOnlyCollection<TableProvider> tables;

    public UnleashedModelProvider(DataModelProvider original)
    {
      this.original = original;
      this.tables = original.Tables
        .Select(table => new UnleashedTableProvider(this, table))
        .Cast<TableProvider>().ToList().AsReadOnly();
    }

    public override Type ContextType
    {
      get { return this.original.ContextType; }
    }

    public override ReadOnlyCollection<TableProvider> Tables
    {
      get { return this.tables; }
    }

    public override object CreateContext()
    {
      return this.original.CreateContext();
    }
  }
}