﻿using System;
using System.Collections.Generic;
using System.Web.DynamicData;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.EntityTemplates
{
  public partial class DefaultEntityTemplate : EntityTemplateUserControl
  {
    private MetaColumn currentColumn;

    protected override void OnLoad(EventArgs e)
    {
      IEnumerable<MetaColumn> scaffoldColumns = this.Table.GetScaffoldColumns(this.Mode, this.ContainerType);
      foreach (MetaColumn column in scaffoldColumns)
      {
        this.currentColumn = column;
        var container = new NamingContainer();
        this.entityTemplate.ItemTemplate.InstantiateIn(container);
        this.entityTemplate.Controls.Add(container);
      }
    }

    protected void Label_Init(object sender, EventArgs e)
    {
      ((UnleashedLabel)sender).DataField = this.currentColumn.Name;
    }

    protected void DynamicControl_Init(object sender, EventArgs e)
    {
      ((UnleashedControl)sender).DataField = this.currentColumn.Name;
    }
  }
}