﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web.DynamicData;
using System.Web.UI.WebControls;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.EntityTemplates
{
  public partial class TwoColumnEntityTemplate : EntityTemplateUserControl
  {
    private MetaColumn currentColumn;

    protected override void OnLoad(EventArgs e)
    {
      IEnumerable<MetaColumn> scaffoldColumns = this.Table.GetScaffoldColumns(this.Mode, this.ContainerType);
      foreach (MetaColumn column in scaffoldColumns)
      {
        this.currentColumn = column;
        var container = new NamingContainer();
        this.entityTemplate.ItemTemplate.InstantiateIn(container);
        PlaceHolder placeHolder = this.FindGroupPlaceHolder(column);
        placeHolder.Controls.Add(container);
      }
    }

    protected void Label_Init(object sender, EventArgs e)
    {
      ((UnleashedLabel)sender).DataField = this.currentColumn.Name;
    }

    protected void DynamicControl_Init(object sender, EventArgs e)
    {
      ((UnleashedControl)sender).DataField = this.currentColumn.Name;
    }

    private PlaceHolder FindGroupPlaceHolder(MetaColumn column)
    {
      PlaceHolder placeHolder = null;
      DisplayAttribute display = column.Attributes.OfType<DisplayAttribute>().FirstOrDefault();
      if (display != null && !string.IsNullOrWhiteSpace(display.GroupName))
        placeHolder = (PlaceHolder)this.FindControl(display.GroupName);
      return placeHolder ?? this.left;
    }
  }
}