﻿using System;
using System.Collections.Specialized;
using System.Web.UI;
using System.Web.UI.WebControls;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.FieldTemplates
{
  public partial class ForeignKey_EditField : UnleashedFieldTemplate
  {
    public override Control DataControl
    {
      get { return this.dropDownList; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
      this.dropDownList.ToolTip = this.Column.Description;

      if (this.dropDownList.Items.Count == 0)
      {
        if (this.Mode == DataBoundControlMode.Insert || !this.Column.IsRequired)
          this.dropDownList.Items.Add(new ListItem("[Not Set]", string.Empty));
        this.PopulateListControl(this.dropDownList);
      }

      this.SetUpValidator(this.requiredFieldValidator);
      this.SetUpValidator(this.dynamicValidator);
    }

    protected override void OnDataBinding(EventArgs e)
    {
      base.OnDataBinding(e);

      string selectedValueString = this.GetSelectedValueString();
      if (this.dropDownList.Items.FindByValue(selectedValueString) != null)
        this.dropDownList.SelectedValue = selectedValueString;
    }

    protected override void ExtractValues(IOrderedDictionary dictionary)
    {
      this.ExtractForeignKey(dictionary, this.dropDownList.SelectedValue);
    }

    protected override void OnFieldValueChanged(EventArgs e)
    {
      base.OnFieldValueChanged(e);
      if (this.dropDownList.Items.FindByValue(this.FieldValueString) != null)
        this.dropDownList.SelectedValue = this.FieldValueString;
    }

    protected void DropDownList_SelectedIndexChanged(object sender, EventArgs e)
    {
      this.OnFieldValueChanged(e);
    }
  }
}