﻿namespace WebApplication.DynamicData.FieldTemplates
{
  using System;
  using System.Collections.Specialized;
  using System.Web.UI;
  using Unleashed.DynamicData;

  public partial class RegionEditField : UnleashedFieldTemplate
  {
    private UnleashedFieldTemplate countryFieldTemplate;

    public string Country
    {
      get { return this.autoCompleteExtender.ContextKey; }
      set { this.autoCompleteExtender.ContextKey = value; }
    }

    public string CountryField { get; set; }

    public override Control DataControl
    {
      get { return this.textBox; }
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.textBox.ToolTip = this.Column.Description;
      this.SetUpValidator(this.requiredFieldValidator);
      this.SetUpValidator(this.dynamicValidator);
    }

    protected override void OnLoad(EventArgs e)
    {
      base.OnLoad(e);

      this.countryFieldTemplate = this.FindOtherFieldTemplate(this.CountryField);
      if (this.countryFieldTemplate != null)
      {
        this.countryFieldTemplate.AutoPostBack = true;
        this.countryFieldTemplate.DataBinding += this.CountryFieldValueChanged;
        this.countryFieldTemplate.FieldValueChanged += this.CountryFieldValueChanged;
      }
    }

    protected override void ExtractValues(IOrderedDictionary dictionary)
    {
      dictionary[this.Column.Name] = this.ConvertEditedValue(this.textBox.Text);
    }

    protected void TextBox_TextChanged(object sender, EventArgs e)
    {
      this.OnFieldValueChanged(e);
    }

    private void CountryFieldValueChanged(object sender, EventArgs args)
    {
      this.Country = this.countryFieldTemplate.FieldValueEditString;
    }
  }
}