﻿using System;
using System.Web.DynamicData;
using System.Web.Security;
using System.Web.UI.WebControls;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.PageTemplates
{
  public partial class Details : System.Web.UI.Page
  {
    protected UnleashedMetaTable table;

    protected override void OnPreInit(EventArgs e)
    {
      base.OnPreInit(e);
      this.table = (UnleashedMetaTable)DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      if (!this.table.CanRead(this.User))
      {
        FormsAuthentication.RedirectToLoginPage();
        this.Response.End();
      }
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.Title = this.table.DisplayName;
      this.dataSource.EntityTypeFilter = this.table.EntityType.Name;
      this.dataSource.Include = this.table.ForeignKeyColumnsNames;
    }

    protected void EditLink_Init(object sender, EventArgs e)
    {
      ((DynamicHyperLink)sender).Visible = this.table.CanUpdate(this.User);
    }

    protected void DeleteLink_Init(object sender, EventArgs e)
    {
      ((DynamicHyperLink)sender).Visible = this.table.CanDelete(this.User);
    }

    protected void DataSource_QueryCreated(object sender, QueryCreatedEventArgs e)
    {
      e.Query = this.table.GetQueryable(e.Query);
    }
  }
}
