﻿using System;
using System.Web.DynamicData;
using System.Web.Security;
using System.Web.UI.WebControls;
using Unleashed.DynamicData;

namespace WebApplication.DynamicData.PageTemplates
{
  public partial class Edit : System.Web.UI.Page
  {
    protected UnleashedMetaTable table;

    protected override void OnPreInit(EventArgs e)
    {
      base.OnPreInit(e);
      this.table = (UnleashedMetaTable)DynamicDataRouteHandler.GetRequestMetaTable(this.Context);
      if (!this.table.CanRead(this.User) || !this.table.CanUpdate(this.User))
      {
        FormsAuthentication.RedirectToLoginPage();
        this.Response.End();
      }
    }

    protected override void OnInit(EventArgs e)
    {
      base.OnInit(e);
      this.Title = this.table.DisplayName;
      this.dataSource.EntityTypeFilter = this.table.EntityType.Name;
      this.dataSource.Include = this.table.ForeignKeyColumnsNames;
    }

    protected void FormView_ItemCommand(object sender, FormViewCommandEventArgs e)
    {
      if (e.CommandName == DataControlCommands.CancelCommandName)
        this.Response.Redirect(this.table.ListActionPath);
    }

    protected void FormView_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
      if (e.Exception == null || e.ExceptionHandled)
        this.Response.Redirect(this.table.ListActionPath);
    }

    protected void DataSource_QueryCreated(object sender, QueryCreatedEventArgs e)
    {
      e.Query = this.table.GetQueryable(e.Query);
    }
  }
}
