﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EntityFrameworkSamples.Inheritance
{
  static class Examples
  {
    public static void InsertEntity()
    {
      using (InheritanceEntities context = new InheritanceEntities())
      {
        Customer c = new Customer();
        c.CustomerID = "SYCHO";
        c.ContactName = "Oleg Sych";
        c.Address = "4300 West Cypress Street";
        c.City = "Tampa";
        c.Region = "FL";
        c.PostalCode = "33607";

        context.Users.AddObject(c);
        context.SaveChanges();
      }
    }

    public static void ReadEntity()
    {
      using (InheritanceEntities context = new InheritanceEntities())
      {
        var query = from c in context.Users.OfType<Customer>()
                    select c;

        foreach (Customer c in query)
          Console.WriteLine(c.ContactName + " " + c.Address);
      }
    }

    public static void ReadBaseType()
    {
      using (InheritanceEntities context = new InheritanceEntities())
      {
        var query = from u in context.Users
                    select u;

        foreach (User u in query)
          Console.WriteLine(u.ContactName + " " + u.GetType().Name);
      }
    }
  }
}
