﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EntityFrameworkSamples.Split
{
  static class Examples
  {
    public static void InsertEntity()
    {
      using (SplitEntities context = new SplitEntities())
      {
        Customer c = new Customer();
        c.CustomerID = "SYCHO";
        c.ContactName = "Oleg Sych";
        c.CompanyName = "AgileThought";
        c.Address = "4300 West Cypress Street";
        c.City = "Tampa";
        c.Region = "FL";
        c.PostalCode = "33607";

        context.Customers.AddObject(c);
        context.SaveChanges();
      }
    }

    public static void ReadEntity()
    {
      using (SplitEntities context = new SplitEntities())
      {
        var query = from c in context.Customers
                    select c;
        foreach (Customer c in query)
          Console.WriteLine(c.ContactName + " " + c.Address);
      }
    }
  }
}
