﻿using System;
using System.Linq;
using System.Web.DynamicData;
using System.Web.Security;
using DataModel;

namespace WebApplication.Samples.Ch05.LinqFilter
{
  public partial class SamplePage : System.Web.UI.Page
  {
    protected override void OnPreInit(EventArgs e)
    {
      base.OnPreInit(e);
      MetaTable table = Global.DefaultModel.GetTable(typeof(Customer));
      if (!table.CanRead(this.User))
      {
        FormsAuthentication.RedirectToLoginPage();
        this.Response.End();
      }
    }

    protected void Find_Click(object sender, EventArgs e)
    {
      using (NorthwindEntities context = new NorthwindEntities())
      {
        IQueryable<Customer> customers = context.Customers;

        if (this.cityFilter.Text.Length > 0)
        {
          customers = customers.Where(c => c.City == this.cityFilter.Text);
        }

        if (this.titleFilter.Text.Length > 0)
        {
          customers = customers.Where(c => c.ContactTitle == this.titleFilter.Text);
        }

        this.gridView.DataSource = customers.ToArray();
        this.gridView.DataBind();
      }
    }
  }
}